<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>Task 3</title>
    <link rel="stylesheet" href="css/normalize.css" />
    <link rel="stylesheet" href="css/style.css" />
  </head>
  <body>
    <div class="wrap" id="wrap">
      <h1>Переключение слайдера</h1>
      <div class="roadMap__container yellow">
        <button class="navButton" data-direction="<"> Prev </button>
        <div class="roadMap">
          <div class="roadMapPoint" data-id="1"></div>
          <div class="roadMapPoint ball" data-id="2"></div>
          <div class="roadMapPoint" data-id="3"></div>
          <div class="roadMapPoint" data-id="4"></div>
          <div class="roadMapPoint" data-id="5"></div>
          <div class="roadMapPoint" data-id="6"></div>
          <div class="roadMapPoint" data-id="7"></div>
          <div class="roadMapPoint" data-id="8"></div>
        </div>
        <button class="navButton" data-direction=">"> Next </button>
      </div>

      <div class="roadMap__container red">
        <button class="navButton" data-direction="<"> Prev </button>
        <div class="roadMap">
          <div class="roadMapPoint" data-id="1"></div>
          <div class="roadMapPoint" data-id="2"></div>
          <div class="roadMapPoint ball" data-id="3"></div>
          <div class="roadMapPoint" data-id="4"></div>
        </div>
        <button class="navButton" data-direction=">"> Next </button>
      </div>

      <div class="roadMap__container blue">
        <button class="navButton" data-direction="<"> Prev </button>
        <div class="roadMap">
          <div class="roadMapPoint" data-id="1"></div>
          <div class="roadMapPoint ball" data-id="2"></div>
          <div class="roadMapPoint" data-id="3"></div>
          <div class="roadMapPoint" data-id="4"></div>
        </div>
        <button class="navButton" data-direction=">"> Next </button>
      </div>


      <div class="roadMap__container red">
          <button class="navButton" data-direction="<"> Prev </button>
          <div class="roadMap">
            <div class="roadMapPoint" data-id="1"></div>
            <div class="roadMapPoint" data-id="2"></div>
            <div class="roadMapPoint ball" data-id="3"></div>
            <div class="roadMapPoint" data-id="4"></div>
          </div>
          <button class="navButton" data-direction=">"> Next </button>
        </div>
  
        <div class="roadMap__container blue">
          <button class="navButton" data-direction="<"> Prev </button>
          <div class="roadMap">
            <div class="roadMapPoint" data-id="1"></div>
            <div class="roadMapPoint ball" data-id="2"></div>
            <div class="roadMapPoint" data-id="3"></div>
            <div class="roadMapPoint" data-id="4"></div>
          </div>
          <button class="navButton" data-direction=">"> Next </button>
        </div>

    </div>
    <script>

      /*
        Задание:

        Написать скрипт, который будет приводить в действие переключалки из разметки.
        И будет перемещать класс ball по точкам в зависимости от нажатой кнопки

      */

      let containers = document.querySelectorAll('.roadMap__container');

      containers.forEach(function(container){
        let prev = container.querySelector('.navButton[data-direction="<"]');
        let next = container.querySelector('.navButton[data-direction=">"]');
        let roadMap = container.querySelector('.roadMap');
        let stepsOnPath = roadMap.querySelectorAll('.roadMapPoint').length;
        
        function move(direction) {
          
          let ball = Number(roadMap.querySelector('.ball').dataset.id);
          let step = Number(ball + direction);

          if (step <= stepsOnPath && step != 0) {
            let place = roadMap.querySelector(`.roadMapPoint[data-id="${ball}"]`);
            let newPlace = roadMap.querySelector(`.roadMapPoint[data-id="${step}"]`);
            place.classList.remove('ball');
            newPlace.classList.add('ball');
          }
        }
       
        prev.addEventListener('click', function() {
          move(-1);
        });

        next.addEventListener('click', function() {
          move(1);
        });
      });

      /*
      console.clear();

      class RoadMap {
        constructor(element) {
          this.element = element;
          this.sliders = element.querySelectorAll('.roadMapPoint');
          this.currentStep = parseInt(element.querySelector('.ball').dataset.id);
          this.totalSteps = this.sliders.length + 1;
          
          this.attachEvents(element);
        }
        
        attachEvents(element, eventName = 'click') {
          const { previousElementSibling: prev, nextElementSibling: next } = element;
          
          prev.addEventListener(eventName, event => {
            this.setStep(-1);
          })

          next.addEventListener(eventName, event => {
            this.setStep(1);
          })
        }
        
        setStep(step = 1) {
          const { totalSteps, currentStep: prevStep } = this;
          const newStep = prevStep + step;
          if(newStep < totalSteps && newStep >= 1) {
            this.currentStep = newStep;
            this.renderStep(prevStep, newStep);
          }
        }
        
        renderStep(prevStep, newStep) {
          const toggleClass = (index, action) => {
            this.element.querySelector(`[data-id='${index}']`).classList[action]('ball');
          }
          
          toggleClass(prevStep, 'remove');
          toggleClass(newStep, 'add');
        }
      }

      // Init
      const roadMaps = document.querySelectorAll('.roadMap');
      roadMaps.forEach(item => {
        let road = new RoadMap(item);
      });
      */
    </script>
  </body>

</html>
